import { PgColumn, PgTableWithColumns } from "drizzle-orm/pg-core";
import { users } from "~/drizzle/schema";
import { lucia } from "~/lib/auth";

declare module "lucia" {
  // eslint-disable-next-line no-unused-vars
  interface Register {
    Lucia: typeof lucia;
    DatabaseUserAttributes: DatabaseUserAttributes;
  }
}

type GetColumns<T> =
  T extends PgTableWithColumns<infer First> ? First["columns"] : never;

type ExtractDataTypes<T> = {
  [K in keyof T]: T[K] extends PgColumn<infer DataType, never, never>
    ? DataType["data"]
    : never;
};

interface DatabaseUserAttributes
  extends ExtractDataTypes<GetColumns<typeof users>> {
  warst: string;
}
